// ConsoleApplication1.cpp : Defines the exported functions for the DLL application.
//

#include "stdafx.h"
#include "testdll.h"

static int threadCounter = 0;
static HANDLE handle = nullptr;
static bool running = true;

static void terminateThread(void)
{
  std::cout << "terminating thread\n";
  running = false;
  WaitForSingleObject(handle, INFINITE);
  std::cout << "done waiting - counter is: " << threadCounter << "\n";
}

static DWORD WINAPI dummy_worker(void*)
{
  threadCounter++;

  while (running) { Sleep(1000); }

  threadCounter--;
  return 0;
}

void startThread(void)
{
  atexit(&terminateThread);

  handle = CreateThread(NULL, 0, &dummy_worker, nullptr, 0, nullptr);
}